package eu.etaxonomy.taxeditor.designproposal2.view;

import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.action.Action;
import org.eclipse.jface.text.Document;
import org.eclipse.jface.text.TextViewer;
import org.eclipse.jface.text.source.SourceViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.PopupList;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.KeyListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.CoolBar;
import org.eclipse.swt.widgets.CoolItem;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorSite;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.part.EditorPart;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

import eu.etaxonomy.taxeditor.designproposal2.view.MySourceViewerConfig;
import eu.etaxonomy.taxeditor.designproposal2.controller.SaveNameAction;
import eu.etaxonomy.taxeditor.designproposal2.model.TaxonName;
import eu.etaxonomy.taxeditor.designproposal2.Activator;
import eu.etaxonomy.taxeditor.designproposal2.controller.OpenNameEditorAction;

//public class CarduusEditorView extends EditorPart implements ICdmEventListener {
public class CarduusEditorView extends EditorPart {

	private Table table_1;
	private Text carduusLSpText;
	private StyledText styledText;
	private TaxonName taxonname;

	public static final String ID = "eu.etaxonomy.taxeditor.designproposal2.view.carduuseditorview"; //$NON-NLS-1$

	/**
	 * Create contents of the editor part
	 * @param parent
	 */
	@Override
	public void createPartControl(Composite parent) {
		//
		
		
//		txtPlay = new Text(container, SWT.BORDER);
//		txtPlay.setCapture(true);
//		final GridData gd_txtPlay = new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1);
//		gd_txtPlay.heightHint = 96;
//		txtPlay.setLayoutData(gd_txtPlay);
////		txtPlay.addVerifyListener(new VerifyListener() {
////			@Override
////			public void verifyText(VerifyEvent e) {
////		        e.doit = Character.isDigit(e.character);
////		    }		
////		});
//		txtPlay.addSelectionListener(new SelectionListener() {
//
//			@Override
//			public void widgetDefaultSelected(SelectionEvent e) {
//				// TODO Auto-generated method stub
//				
//			}
//
//			@Override
//			public void widgetSelected(SelectionEvent e) {
//				System.out.println(e.toString());
//			}
//			
//			
//		});
//		
//		
//		txtPlay.addKeyListener(new KeyListener() {
//
//			public void keyPressed(KeyEvent e) {
//				System.out.println(e.character);
//				if (e.character == '=') {
//					Shell shell = Activator.getDefault().getWorkbench().
//						getActiveWorkbenchWindow().getShell();
//					PopupList list = new PopupList(shell, SWT.H_SCROLL | SWT.V_SCROLL);
//					
////					Combo list = new Combo(shell, SWT.H_SCROLL | SWT.V_SCROLL);
//					
//					// Add the items to the list
//					String[] OPTIONS = { "Create homo. syn.",
//							"Create hetero. syn.",
//							"Create mis. name",
//							"Create homonym"};
//
//					list.setItems(OPTIONS);
//					
//					// Open the list and get the selected item
//					String selected = list.open(txtPlay.getBounds());
//					
//					// Print the item to the console
//					System.out.println(selected);					
//				}
//				
//			}
//
//			public void keyReleased(KeyEvent e) {
//				// TODO Auto-generated method stub
//				
//			}
//		});
		parent.setLayout(new GridLayout());
		Document doc = new Document("");

		final Label taxonomicallyIncludedInLabel = new Label(parent, SWT.NONE);
		taxonomicallyIncludedInLabel.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false));
		taxonomicallyIncludedInLabel.setText("Higher taxon: \"Cardueae Cass.\"");

		final ToolBar toolBar = new ToolBar(parent, SWT.NONE);
//		toolBar.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));

		final ToolItem itemSave = new ToolItem(toolBar, SWT.PUSH);
		itemSave.setToolTipText("Save taxon \"Pilosella fuscoatra (Ngeli & Peter) Sojk\"");
		itemSave.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/save.gif"));
		itemSave.addSelectionListener(new SelectionListener() {
			public void mouseDown(final MouseEvent e) {
				
//				taxonname.setGenus(txtGenus.getText());
//				taxonname.setSpecificEpithet(txtSpEpi.getText());
				
				new SaveNameAction(taxonname).run();
			}

			public void widgetDefaultSelected(SelectionEvent e) {
				new SaveNameAction(taxonname).run();
			}

			public void widgetSelected(SelectionEvent e) {
				new SaveNameAction(taxonname).run();
			}
		});

		final ToolItem itemMove = new ToolItem(toolBar, SWT.DROP_DOWN);
		itemMove.setToolTipText("Move taxon \"Pilosella fuscoatra (Ngeli & Peter) Sojk\"");
		itemMove.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(final SelectionEvent e) {
			}
		});
		
		final Menu menuMove = new Menu(toolBar);
		menuMove.setData("x", null);
		addDropDown(itemMove, menuMove);

		final MenuItem moveTaxonpilosellaMenuItem = new MenuItem(menuMove, SWT.NONE);
		moveTaxonpilosellaMenuItem.setText("Move taxon \"Pilosella fuscoatra (Ngeli & Peter) Sojk\" to another higher taxon");

		final MenuItem turnTaxonpilosellaMenuItem = new MenuItem(menuMove, SWT.NONE);
		turnTaxonpilosellaMenuItem.setText("Turn taxon \"Pilosella fuscoatra (Ngeli & Peter) Sojk\" into a synonym");
		
//		});
//		newItemToolItem.setText("New item");
		itemMove.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/move_no_bg.gif"));

		final ToolItem itemDelete = new ToolItem(toolBar, SWT.NONE);
		itemDelete.setToolTipText("Delete taxon \"Pilosella fuscoatra (Ngeli & Peter) Sojk\"");
		itemDelete.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/delete.gif"));
				
		final ToolItem separator1 = new ToolItem(toolBar, SWT.SEPARATOR);

		final ToolItem itemAddRelationship = new ToolItem(toolBar, SWT.DROP_DOWN);
		itemAddRelationship.setToolTipText("Add nom. or tax. relation to \"Pilosella fuscoatra (Ngeli & Peter) Sojk\"");
		itemAddRelationship.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/rel_no_bg.gif"));
		
		final Menu menuAddRel = new Menu(toolBar);
		menuAddRel.setData("x", null);
		addDropDown(itemAddRelationship, menuAddRel);

		final MenuItem testMenuItem = new MenuItem(menuAddRel, SWT.NONE);
		testMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/unknown_no_bg.gif"));
		testMenuItem.setText("Add synonymy (type unknown)");

		final MenuItem addHomotypicSynonymMenuItem = new MenuItem(menuAddRel, SWT.NONE);
		addHomotypicSynonymMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/homosyn_no_bg.gif"));
		addHomotypicSynonymMenuItem.setText("Add homotypic synonym");

		final MenuItem addHeterotypicSynoynmMenuItem = new MenuItem(menuAddRel, SWT.NONE);
		addHeterotypicSynoynmMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/heterosyn_no_bg.gif"));
		addHeterotypicSynoynmMenuItem.setText("Add heterotypic synoynm");

		final MenuItem addBasionymMenuItem = new MenuItem(menuAddRel, SWT.NONE);
		addBasionymMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/basionym_no_bg.gif"));
		addBasionymMenuItem.setText("Add basionym");

		final MenuItem addReplacedSynonymMenuItem = new MenuItem(menuAddRel, SWT.NONE);
		addReplacedSynonymMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/repsyn_no_bg.gif"));
		addReplacedSynonymMenuItem.setText("Add replaced synonym");

		final MenuItem addHomonymMenuItem = new MenuItem(menuAddRel, SWT.NONE);
		addHomonymMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/homonym_no_bg.gif"));
		addHomonymMenuItem.setText("Add homonym");

		final MenuItem addOrthographicVariantMenuItem = new MenuItem(menuAddRel, SWT.NONE);
		addOrthographicVariantMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/orthovariant_no_bg.gif"));
		addOrthographicVariantMenuItem.setText("Add orthographic variant");

		final MenuItem addMisappliedNameMenuItem = new MenuItem(menuAddRel, SWT.NONE);
		addMisappliedNameMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/misapplied_no_bg.gif"));
		addMisappliedNameMenuItem.setText("Add misapplied name");

		final MenuItem addConceptRelationMenuItem_1 = new MenuItem(menuAddRel, SWT.CASCADE);
		addConceptRelationMenuItem_1.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/concept_no_bg.gif"));
		addConceptRelationMenuItem_1.setText("Add concept relation");

		final Menu menu = new Menu(addConceptRelationMenuItem_1);
		addConceptRelationMenuItem_1.setMenu(menu);

		final MenuItem checkboxMenuItem = new MenuItem(menu, SWT.CHECK);
		checkboxMenuItem.setText("congruent");

		final MenuItem checkboxMenuItem_1 = new MenuItem(menu, SWT.CHECK);
		checkboxMenuItem_1.setSelection(true);
		checkboxMenuItem_1.setText("included in");

		final MenuItem checkboxMenuItem_2 = new MenuItem(menu, SWT.CHECK);
		checkboxMenuItem_2.setText("includes");

		final MenuItem checkboxMenuItem_3 = new MenuItem(menu, SWT.CHECK);
		checkboxMenuItem_3.setText("overlaps");

		final MenuItem checkboxMenuItem_4 = new MenuItem(menu, SWT.CHECK);
		checkboxMenuItem_4.setText("excludes");

		final MenuItem checkboxMenuItem_5 = new MenuItem(menu, SWT.CHECK);
		checkboxMenuItem_5.setSelection(true);
		checkboxMenuItem_5.setText("doubtful");
		
		final ToolItem separator2 = new ToolItem(toolBar, SWT.SEPARATOR);

		final ToolItem itemAddTaxon = new ToolItem(toolBar, SWT.DROP_DOWN);
		itemAddTaxon.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/add_no_bg2.gif"));
		itemAddTaxon.setToolTipText("Add new taxon");

		final Menu menuAdd = new Menu(toolBar);
		menuAdd.setData("x", null);
		addDropDown(itemAddTaxon, menuAdd);

		final MenuItem addTaxonToMenuItem = new MenuItem(menuAdd, SWT.NONE);
		addTaxonToMenuItem.setText("Add new taxon to \"Pilosella fuscoatra (Ngeli & Peter) Sojk\"");

		final MenuItem addNewTaxonMenuItem = new MenuItem(menuAdd, SWT.NONE);
		addNewTaxonMenuItem.setText("Add new taxon to \"Pilosella fuscoatra coll.\"");

		final Composite composite = new Composite(parent, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		composite.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		final GridLayout gridLayout_2 = new GridLayout();
		gridLayout_2.horizontalSpacing = 3;
		gridLayout_2.numColumns = 2;
		composite.setLayout(gridLayout_2);

		carduusLSpText = new Text(composite, SWT.WRAP);
		carduusLSpText.setText("Carduus L., Sp. Pl.: 820. 1753");
		carduusLSpText.setFont(SWTResourceManager.getFont("Georgia", 12, SWT.NONE));
		final GridData gd_carduusLSpText = new GridData(SWT.FILL, SWT.CENTER, true, false);
		carduusLSpText.setLayoutData(gd_carduusLSpText);
		carduusLSpText.addFocusListener(new FocusListener() {

			public void focusGained(FocusEvent e) {
				carduusLSpText.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WIDGET_LIGHT_SHADOW));
			}

			public void focusLost(FocusEvent e) {
				carduusLSpText.setBackground(null);				
			}

		});

		table_1 = new Table(composite, SWT.BORDER);
		table_1.setLinesVisible(true);
		table_1.setLayoutData(new GridData(SWT.RIGHT, SWT.FILL, true, true, 1, 2));

		final TableColumn newColumnTableColumn = new TableColumn(table_1, SWT.NONE);
		newColumnTableColumn.setWidth(100);
		newColumnTableColumn.setText("New column");

		final TableColumn newColumnTableColumn_1 = new TableColumn(table_1, SWT.NONE);
		newColumnTableColumn_1.setWidth(100);
		newColumnTableColumn_1.setText("New column");

		final TableItem newItemTableItem = new TableItem(table_1, SWT.BORDER);
		newItemTableItem.setText(0, "Rank");
		newItemTableItem.setText(1, "genus");
		newItemTableItem.setText("Rank");
		
		final TableItem newItemTableItem_1 = new TableItem(table_1, SWT.BORDER);
		newItemTableItem_1.setText(1, "Carduus");
		newItemTableItem_1.setText(0, "Genus");

		final TableItem newItemTableItem_2 = new TableItem(table_1, SWT.BORDER);
		newItemTableItem_2.setText(0, "Species epithet");

		final TableItem newItemTableItem_3 = new TableItem(table_1, SWT.BORDER);
		newItemTableItem_3.setText(1, "L.");
		newItemTableItem_3.setText(0, "Author team");

		final TableItem newItemTableItem_4 = new TableItem(table_1, SWT.BORDER);
		newItemTableItem_4.setText("...");
//		newItemTableItem_2.setText("Species epithet");
//		newItemTableItem_1.setText("Genus");
		//container.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));

		SourceViewer sourceviewer = new SourceViewer(composite, null, SWT.WRAP | SWT.FULL_SELECTION);
		sourceviewer.setAnnotationHover(null);
		styledText = sourceviewer.getTextWidget();
		final GridData gd_styledText = new GridData(SWT.FILL, SWT.TOP, true, false);
		gd_styledText.heightHint = 41;
		gd_styledText.widthHint = 450;
		styledText.setLayoutData(gd_styledText);
		sourceviewer.setDocument(doc);
		sourceviewer.configure(new MySourceViewerConfig());
		sourceviewer.setTabsToSpacesConverter(null);

		
//		final Menu menu = new Menu(toolBar);
//		addDropDown(newItemToolItem, menu);
//		);
		
//		Action testAction = new OpenNameEditorAction();
//		testAction.setImageDescriptor(ResourceManager.getPluginImageDescriptor(Activator.getDefault(), "icons/edit_16x16.gif"));
//		testAction.setToolTipText("Add relation");
//		toolBar.add(testAction);
		
		populateForm();		
	}

//	private void populateForm() {
//		
//		String fulltext = "";
//		
//		if (taxonname.getGenus() != null) {
//			fulltext = taxonname.getGenus();
//		}
//
//		if (taxonname.getSpecificEpithet() != null) {
//			fulltext += " " + taxonname.getSpecificEpithet();
//		}
//
//		if (taxonname.getAuthorship() != null) {
//			fulltext += " " + taxonname.getAuthorship();
//		}
//		
////		txtPlay.setText(fulltext);
////		txtPlay.setToolTipText("Joe mama\njoe daddy\njoe gramammy");
//		
//		this.setPartName(taxonname.getName());
//	}

	private void populateForm() {
		this.setPartName("Pilosella fuscoatra (Ngeli & Peter) Sojk");
	}
	
	@Override
	public void setFocus() {
		// Set the focus
	}

	@Override
	public void doSave(IProgressMonitor monitor) {
		// Do the Save operation
	}

	@Override
	public void doSaveAs() {
		// Do the Save As operation
	}

	@Override
	public void init(IEditorSite site, IEditorInput input) throws PartInitException {

		if (!(input instanceof IEditorInput))
			throw new PartInitException(
					"Invalid Input: Must be IFileEditorInput");
		
		if (input.getAdapter(TaxonName.class) != null) {
			taxonname = (TaxonName) input.getAdapter(TaxonName.class);
//			taxonname.addCdmEventListener(this);
		} else {
			
			taxonname = null;
		}
		
		setSite(site);
		setInput(input);
	}

	@Override
	public boolean isDirty() {
		return false;
	}

	@Override
	public boolean isSaveAsAllowed() {
		return false;
	}

	public void propertyChange(PropertyChangeEvent evt) {
//		TaxonName taxonname = (TaxonName)evt.getNewValue();
		this.taxonname = (TaxonName)evt.getNewValue();
		System.out.println(((TaxonName)evt.getNewValue()).getName());
		populateForm();
		
		// for individual fields, do something like:
		//	if (evt.getPropertyName().equalsIgnoreCase("genus"))
		//		txtGenus.setText ...
	}

//	public void onDelete(ICdmEventListenerRegistration arg0) {
//		// TODO Auto-generated method stub
//		
//	}

	public void onInsert(Object arg0) {
		// TODO Auto-generated method stub
		
	}

	public void onLoad(Object arg0) {
		// TODO Auto-generated method stub
		
	}

//	public void onUpdate(ICdmEventListenerRegistration arg0) {
//		// TODO Auto-generated method stub
//		
//	}
	
	private static void addDropDown(final ToolItem item, final Menu menu) {
		item.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				if (event.detail == SWT.ARROW) {
					Rectangle rect = item.getBounds();
					Point pt = new Point(rect.x, rect.y + rect.height);
					pt = item.getParent().toDisplay(pt);
					menu.setLocation(pt.x, pt.y);
					menu.setVisible(true);
				}
			}
		});
	}
}
