package eu.etaxonomy.taxeditor.prototype2.view;

import java.beans.PropertyChangeEvent;

import org.eclipse.core.runtime.IProgressMonitor;
import org.eclipse.jface.text.Document;
import org.eclipse.jface.text.source.SourceViewer;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.FocusListener;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.ToolBar;
import org.eclipse.swt.widgets.ToolItem;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorSite;
import org.eclipse.ui.PartInitException;
import org.eclipse.ui.part.EditorPart;

import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

import eu.etaxonomy.taxeditor.prototype2.Activator;
import eu.etaxonomy.taxeditor.prototype2.controller.ActionSaveTaxon;
import eu.etaxonomy.taxeditor.prototype2.view.nameviewersupport.MySourceViewerConfig;

//public class PilosellaEditorView extends EditorPart implements ICdmEventListener {
public class PilosellaEditorView extends EditorPart {

	private Text hieraciumFuscoatrumSubspText_1;
	private Text hieraciumRubroonegenseNorrlText;
	private Table table_1;
	private Text text_3;
	private Text hieraciumFuscoatrumSubspText;
	private Text hieraciumAurantiacumSubspText;
	private Text text_1;
	private StyledText styledText;
	private TaxonName taxonname;

	public static final String ID = "eu.etaxonomy.taxeditor.prototype2.view.pilosellaeditorview"; //$NON-NLS-1$

	/**
	 * Create contents of the editor part
	 * @param parent
	 */
	@Override
	public void createPartControl(Composite parent) {
		//
		
		
//		txtPlay = new Text(container, SWT.BORDER);
//		txtPlay.setCapture(true);
//		final GridData gd_txtPlay = new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1);
//		gd_txtPlay.heightHint = 96;
//		txtPlay.setLayoutData(gd_txtPlay);
////		txtPlay.addVerifyListener(new VerifyListener() {
////			@Override
////			public void verifyText(VerifyEvent e) {
////		        e.doit = Character.isDigit(e.character);
////		    }		
////		});
//		txtPlay.addSelectionListener(new SelectionListener() {
//
//			@Override
//			public void widgetDefaultSelected(SelectionEvent e) {
//				// TODO Auto-generated method stub
//				
//			}
//
//			@Override
//			public void widgetSelected(SelectionEvent e) {
//				System.out.println(e.toString());
//			}
//			
//			
//		});
//		
//		
//		txtPlay.addKeyListener(new KeyListener() {
//
//			public void keyPressed(KeyEvent e) {
//				System.out.println(e.character);
//				if (e.character == '=') {
//					Shell shell = Activator.getDefault().getWorkbench().
//						getActiveWorkbenchWindow().getShell();
//					PopupList list = new PopupList(shell, SWT.H_SCROLL | SWT.V_SCROLL);
//					
////					Combo list = new Combo(shell, SWT.H_SCROLL | SWT.V_SCROLL);
//					
//					// Add the items to the list
//					String[] OPTIONS = { "Create homo. syn.",
//							"Create hetero. syn.",
//							"Create mis. name",
//							"Create homonym"};
//
//					list.setItems(OPTIONS);
//					
//					// Open the list and get the selected item
//					String selected = list.open(txtPlay.getBounds());
//					
//					// Print the item to the console
//					System.out.println(selected);					
//				}
//				
//			}
//
//			public void keyReleased(KeyEvent e) {
//				// TODO Auto-generated method stub
//				
//			}
//		});
		parent.setLayout(new GridLayout());
		Document doc = new Document("");

		final Label taxonomicallyIncludedInLabel = new Label(parent, SWT.NONE);
		taxonomicallyIncludedInLabel.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false));
		taxonomicallyIncludedInLabel.setText("Higher taxon: \"Pilosella fuscoatra coll.\"");

		final ToolBar toolBar = new ToolBar(parent, SWT.NONE);
//		toolBar.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));

		final ToolItem itemSave = new ToolItem(toolBar, SWT.PUSH);
		itemSave.setToolTipText("Save taxon \"Pilosella fuscoatra (Ngeli & Peter) Sojk\"");
		itemSave.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/save.gif"));
		itemSave.addSelectionListener(new SelectionListener() {
			public void mouseDown(final MouseEvent e) {
				
//				taxonname.setGenus(txtGenus.getText());
//				taxonname.setSpecificEpithet(txtSpEpi.getText());
				
				new ActionSaveTaxon(taxonname).run();
			}

			public void widgetDefaultSelected(SelectionEvent e) {
				new ActionSaveTaxon(taxonname).run();
			}

			public void widgetSelected(SelectionEvent e) {
				new ActionSaveTaxon(taxonname).run();
			}
		});

		final ToolItem itemMove = new ToolItem(toolBar, SWT.DROP_DOWN);
		itemMove.setToolTipText("Move taxon \"Pilosella fuscoatra (Ngeli & Peter) Sojk\"");
		
		final Menu menuMove = new Menu(toolBar);
		menuMove.setData("x", null);
		addDropDown(itemMove, menuMove);

		final MenuItem moveTaxonpilosellaMenuItem = new MenuItem(menuMove, SWT.NONE);
		moveTaxonpilosellaMenuItem.setText("Move taxon \"Pilosella fuscoatra (Ngeli & Peter) Sojk\" to another higher taxon");

		final MenuItem turnTaxonpilosellaMenuItem = new MenuItem(menuMove, SWT.NONE);
		turnTaxonpilosellaMenuItem.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(final SelectionEvent e) {
				new MoveDialogView(getSite().getShell());
//				MessageDialog.openInformation(getSite().getShell(),"Readme Editor","View Action executed");				
				MoveDialogView dialog = new MoveDialogView(getSite().getShell());
				dialog.open();				
			}
		});
		turnTaxonpilosellaMenuItem.setText("Turn taxon \"Pilosella fuscoatra (Ngeli & Peter) Sojk\" into a synonym");
		
//		});
//		newItemToolItem.setText("New item");
		itemMove.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/move_no_bg.gif"));

		final ToolItem itemDelete = new ToolItem(toolBar, SWT.NONE);
		itemDelete.setToolTipText("Delete taxon \"Pilosella fuscoatra (Ngeli & Peter) Sojk\"");
		itemDelete.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/delete.gif"));
				
		final ToolItem separator1 = new ToolItem(toolBar, SWT.SEPARATOR);

		final ToolItem itemAddRelationship = new ToolItem(toolBar, SWT.DROP_DOWN);
		itemAddRelationship.setToolTipText("Add nom. or tax. relation to \"Pilosella fuscoatra (Ngeli & Peter) Sojk\"");
		itemAddRelationship.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/rel_no_bg.gif"));
		
		final Menu menuAddRel = new Menu(toolBar);
		menuAddRel.setData("x", null);
		addDropDown(itemAddRelationship, menuAddRel);

		final MenuItem testMenuItem = new MenuItem(menuAddRel, SWT.NONE);
		testMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/unknown_no_bg.gif"));
		testMenuItem.setText("Add synonymy (type unknown)");

		final MenuItem addHomotypicSynonymMenuItem = new MenuItem(menuAddRel, SWT.NONE);
		addHomotypicSynonymMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/homosyn_no_bg.gif"));
		addHomotypicSynonymMenuItem.setText("Add homotypic synonym");

		final MenuItem addHeterotypicSynoynmMenuItem = new MenuItem(menuAddRel, SWT.NONE);
		addHeterotypicSynoynmMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/heterosyn_no_bg.gif"));
		addHeterotypicSynoynmMenuItem.setText("Add heterotypic synoynm");

		final MenuItem addBasionymMenuItem = new MenuItem(menuAddRel, SWT.NONE);
		addBasionymMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/basionym_no_bg.gif"));
		addBasionymMenuItem.setText("Add basionym");

		final MenuItem addReplacedSynonymMenuItem = new MenuItem(menuAddRel, SWT.NONE);
		addReplacedSynonymMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/repsyn_no_bg.gif"));
		addReplacedSynonymMenuItem.setText("Add replaced synonym");

		final MenuItem addHomonymMenuItem = new MenuItem(menuAddRel, SWT.NONE);
		addHomonymMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/homonym_no_bg.gif"));
		addHomonymMenuItem.setText("Add homonym");

		final MenuItem addOrthographicVariantMenuItem = new MenuItem(menuAddRel, SWT.NONE);
		addOrthographicVariantMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/orthovariant_no_bg.gif"));
		addOrthographicVariantMenuItem.setText("Add orthographic variant");

		final MenuItem addMisappliedNameMenuItem = new MenuItem(menuAddRel, SWT.NONE);
		addMisappliedNameMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/misapplied_no_bg.gif"));
		addMisappliedNameMenuItem.setText("Add misapplied name");

		final MenuItem addConceptRelationMenuItem_1 = new MenuItem(menuAddRel, SWT.CASCADE);
		addConceptRelationMenuItem_1.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/concept_no_bg.gif"));
		addConceptRelationMenuItem_1.setText("Add concept relation");

		final Menu menu = new Menu(addConceptRelationMenuItem_1);
		addConceptRelationMenuItem_1.setMenu(menu);

		final MenuItem checkboxMenuItem = new MenuItem(menu, SWT.CHECK);
		checkboxMenuItem.setText("congruent");

		final MenuItem checkboxMenuItem_1 = new MenuItem(menu, SWT.CHECK);
		checkboxMenuItem_1.setSelection(true);
		checkboxMenuItem_1.setText("included in");

		final MenuItem checkboxMenuItem_2 = new MenuItem(menu, SWT.CHECK);
		checkboxMenuItem_2.setText("includes");

		final MenuItem checkboxMenuItem_3 = new MenuItem(menu, SWT.CHECK);
		checkboxMenuItem_3.setText("overlaps");

		final MenuItem checkboxMenuItem_4 = new MenuItem(menu, SWT.CHECK);
		checkboxMenuItem_4.setText("excludes");

		final MenuItem checkboxMenuItem_5 = new MenuItem(menu, SWT.CHECK);
		checkboxMenuItem_5.setSelection(true);
		checkboxMenuItem_5.setText("doubtful");
		
		final ToolItem separator2 = new ToolItem(toolBar, SWT.SEPARATOR);

		final ToolItem itemAddTaxon = new ToolItem(toolBar, SWT.DROP_DOWN);
		itemAddTaxon.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/add_no_bg2.gif"));
		itemAddTaxon.setToolTipText("Add new taxon");

		final Menu menuAdd = new Menu(toolBar);
		menuAdd.setData("x", null);
		addDropDown(itemAddTaxon, menuAdd);

		final MenuItem addTaxonToMenuItem = new MenuItem(menuAdd, SWT.NONE);
		addTaxonToMenuItem.setText("Add new taxon to \"Pilosella fuscoatra (Ngeli & Peter) Sojk\"");

		final MenuItem addNewTaxonMenuItem = new MenuItem(menuAdd, SWT.NONE);
		addNewTaxonMenuItem.setText("Add new taxon to \"Pilosella fuscoatra coll.\"");

		final Composite composite = new Composite(parent, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true));
		composite.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		final GridLayout gridLayout_2 = new GridLayout();
		gridLayout_2.horizontalSpacing = 3;
		gridLayout_2.numColumns = 3;
		composite.setLayout(gridLayout_2);

		text_3 = new Text(composite, SWT.WRAP);
		text_3.setText("Pilosella fuscoatra (Ngeli & Peter) Sojk in Preslia 43: 184. 1971 ");
		text_3.setFont(SWTResourceManager.getFont("Georgia", 12, SWT.NONE));
		text_3.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
		text_3.addFocusListener(new FocusListener() {

			public void focusGained(FocusEvent e) {
				text_3.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WIDGET_LIGHT_SHADOW));
			}

			public void focusLost(FocusEvent e) {
				text_3.setBackground(null);				
			}

		});

		table_1 = new Table(composite, SWT.BORDER);
		table_1.setLinesVisible(true);
		table_1.setLayoutData(new GridData(SWT.RIGHT, SWT.FILL, true, true, 1, 7));

		final TableColumn newColumnTableColumn = new TableColumn(table_1, SWT.NONE);
		newColumnTableColumn.setWidth(100);
		newColumnTableColumn.setText("New column");

		final TableColumn newColumnTableColumn_1 = new TableColumn(table_1, SWT.NONE);
		newColumnTableColumn_1.setWidth(100);
		newColumnTableColumn_1.setText("New column");

		final TableItem newItemTableItem = new TableItem(table_1, SWT.BORDER);
		newItemTableItem.setText(0, "Rank");
		newItemTableItem.setText(1, "species");
		newItemTableItem.setText("Rank");
		
		final TableItem newItemTableItem_1 = new TableItem(table_1, SWT.BORDER);
		newItemTableItem_1.setText(1, "Pilosella");
		newItemTableItem_1.setText(0, "Genus");

		final TableItem newItemTableItem_2 = new TableItem(table_1, SWT.BORDER);
		newItemTableItem_2.setText(1, "fuscoatra");
		newItemTableItem_2.setText(0, "Species epithet");

		final TableItem newItemTableItem_3 = new TableItem(table_1, SWT.BORDER);
		newItemTableItem_3.setText(1, "Ngeli & Peter");
		newItemTableItem_3.setText(0, "Author team");

		final TableItem newItemTableItem_4 = new TableItem(table_1, SWT.BORDER);
		newItemTableItem_4.setText("...");
//		newItemTableItem_3.setText("Author team");
//		newItemTableItem_2.setText("Species epithet");
//		newItemTableItem_1.setText("Genus");

		final Label labelWithMenu = new Label(composite, SWT.NONE);
		labelWithMenu.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		labelWithMenu.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/homosyn_no_bg.gif"));
		final GridData gd_labelWithMenu = new GridData(SWT.LEFT, SWT.TOP, false, false);
		labelWithMenu.setLayoutData(gd_labelWithMenu);
		
		text_1 = new Text(composite, SWT.WRAP);
		final GridData gd_text_1 = new GridData(SWT.FILL, SWT.CENTER, true, false);
		gd_text_1.widthHint = 300;
		text_1.setLayoutData(gd_text_1);
		text_1.setFont(SWTResourceManager.getFont("Georgia", 11, SWT.NONE));
		text_1.setText("Hieracium fuscoatrum Ngeli & Peter, Hierac. Mitt.-Eur. 1: 315. 1885");
		text_1.addFocusListener(new FocusListener() {

			public void focusGained(FocusEvent e) {
				text_1.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WIDGET_LIGHT_SHADOW));
			}

			public void focusLost(FocusEvent e) {
				text_1.setBackground(null);				
			}

		});
		

		final Label label_1 = new Label(composite, SWT.NONE);
		label_1.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, false));
		label_1.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/heterosyn_no_bg.gif"));
		label_1.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));

		hieraciumAurantiacumSubspText = new Text(composite, SWT.WRAP);
		final GridData gd_hieraciumAurantiacumSubspText = new GridData(SWT.FILL, SWT.CENTER, true, false);
		gd_hieraciumAurantiacumSubspText.widthHint = 300;
		hieraciumAurantiacumSubspText.setLayoutData(gd_hieraciumAurantiacumSubspText);
		hieraciumAurantiacumSubspText.setFont(SWTResourceManager.getFont("Georgia", 11, SWT.NONE));
		hieraciumAurantiacumSubspText.setText("Hieracium aurantiacum subsp. chaetodermum Pohle & Zahn in Allg. Bot. Z. Syst. 13: 110. 1907");
		hieraciumAurantiacumSubspText.addFocusListener(new FocusListener() {

			public void focusGained(FocusEvent e) {
				hieraciumAurantiacumSubspText.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WIDGET_LIGHT_SHADOW));
			}

			public void focusLost(FocusEvent e) {
				hieraciumAurantiacumSubspText.setBackground(null);				
			}

		});
		

		final Label label_2 = new Label(composite, SWT.NONE);
		label_2.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, false));
		label_2.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		label_2.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/heterosyn_no_bg.gif"));

		hieraciumFuscoatrumSubspText = new Text(composite, SWT.WRAP);
		final GridData gd_hieraciumFuscoatrumSubspText = new GridData(SWT.FILL, SWT.CENTER, true, false);
		gd_hieraciumFuscoatrumSubspText.widthHint = 300;
		hieraciumFuscoatrumSubspText.setLayoutData(gd_hieraciumFuscoatrumSubspText);
		hieraciumFuscoatrumSubspText.setText("Hieracium fuscoatrum subsp. chaetodermum (Pohle & Zahn) Zahn in Engler, Pflanzenr. 82: 1267. 1923");
		hieraciumFuscoatrumSubspText.setFont(SWTResourceManager.getFont("Georgia", 11, SWT.NONE));
		hieraciumFuscoatrumSubspText.addFocusListener(new FocusListener() {

			public void focusGained(FocusEvent e) {
				hieraciumFuscoatrumSubspText.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WIDGET_LIGHT_SHADOW));
			}

			public void focusLost(FocusEvent e) {
				hieraciumFuscoatrumSubspText.setBackground(null);				
			}

		});

		final Label label = new Label(composite, SWT.NONE);
		label.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, false));
		label.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		label.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/basionym_no_bg.gif"));

		hieraciumRubroonegenseNorrlText = new Text(composite, SWT.WRAP);
		hieraciumRubroonegenseNorrlText.setText("Hieracium rubroonegense Norrl. in Acta Soc. Fauna Fl. Fenn. 26(7): 61. 1904");
		hieraciumRubroonegenseNorrlText.setFont(SWTResourceManager.getFont("Georgia", 11, SWT.NONE));
		hieraciumRubroonegenseNorrlText.addFocusListener(new FocusListener() {

			public void focusGained(FocusEvent e) {
				hieraciumRubroonegenseNorrlText.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WIDGET_LIGHT_SHADOW));
			}

			public void focusLost(FocusEvent e) {
				hieraciumRubroonegenseNorrlText.setBackground(null);				
			}

		});		
		final GridData gd_hieraciumRubroonegenseNorrlText = new GridData(SWT.FILL, SWT.CENTER, true, false);
		gd_hieraciumRubroonegenseNorrlText.widthHint = 300;
		hieraciumRubroonegenseNorrlText.setLayoutData(gd_hieraciumRubroonegenseNorrlText);

		final Label label_3 = new Label(composite, SWT.NONE);
		label_3.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, false));
		label_3.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/repsyn_no_bg.gif"));
		label_3.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));

		hieraciumFuscoatrumSubspText_1 = new Text(composite, SWT.WRAP);
		hieraciumFuscoatrumSubspText_1.setText("Hieracium fuscoatrum subsp. rubroonegense (Norrl.) Zahn in Engler, Pflanzenr. 82: 1267. 1923");
		hieraciumFuscoatrumSubspText_1.setFont(SWTResourceManager.getFont("Georgia", 11, SWT.NONE));
		hieraciumFuscoatrumSubspText_1.addFocusListener(new FocusListener() {

			public void focusGained(FocusEvent e) {
				hieraciumFuscoatrumSubspText_1.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WIDGET_LIGHT_SHADOW));
			}

			public void focusLost(FocusEvent e) {
				hieraciumFuscoatrumSubspText_1.setBackground(null);				
			}

		});	
		final GridData gd_hieraciumFuscoatrumSubspText_1 = new GridData(SWT.FILL, SWT.CENTER, true, false);
		gd_hieraciumFuscoatrumSubspText_1.widthHint = 300;
		hieraciumFuscoatrumSubspText_1.setLayoutData(gd_hieraciumFuscoatrumSubspText_1);
		
		final Label label_4 = new Label(composite, SWT.NONE);
		label_4.setLayoutData(new GridData(SWT.LEFT, SWT.TOP, false, false));
		label_4.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/unknown_no_bg.gif"));
		label_4.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_WHITE));
		//container.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));

		final Menu menu1 = new Menu(labelWithMenu);
		labelWithMenu.setMenu(menu1);

		final MenuItem deletehieraciumFuscoatrumMenuItem = new MenuItem(menu1, SWT.NONE);
		deletehieraciumFuscoatrumMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/delete.gif"));
		deletehieraciumFuscoatrumMenuItem.setText("Delete \"Hieracium fuscoatrum Ngeli & Peter\" from this taxon");

		new MenuItem(menu1, SWT.SEPARATOR);

		final MenuItem moveMenuItem = new MenuItem(menu1, SWT.NONE);
		moveMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/move_no_bg.gif"));
		moveMenuItem.setText("Move \"Hieracium fuscoatrum Ngeli & Peter\" to another taxon");

		final MenuItem makehieraciumFuscoatrumMenuItem = new MenuItem(menu1, SWT.NONE);
		makehieraciumFuscoatrumMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/a_no_bg.gif"));
		makehieraciumFuscoatrumMenuItem.setText("Turn \"Hieracium fuscoatrum Ngeli & Peter\" into an accepted name");

		new MenuItem(menu1, SWT.SEPARATOR);

		final MenuItem turnhieraciumFuscoatrumMenuItem = new MenuItem(menu1, SWT.NONE);
		turnhieraciumFuscoatrumMenuItem.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/unknown_no_bg.gif"));
		turnhieraciumFuscoatrumMenuItem.setText("Turn \"Hieracium fuscoatrum Ngeli & Peter\" into a synonym (type unknown)");

		final MenuItem turnhieraciumFuscoatrumMenuItem_1 = new MenuItem(menu1, SWT.NONE);
		turnhieraciumFuscoatrumMenuItem_1.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/homosyn_no_bg.gif"));
		turnhieraciumFuscoatrumMenuItem_1.setText("Turn \"Hieracium fuscoatrum Ngeli & Peter\" into a homotypic synonym");

		final MenuItem turnhieraciumFuscoatrumMenuItem_2 = new MenuItem(menu1, SWT.NONE);
		turnhieraciumFuscoatrumMenuItem_2.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/heterosyn_no_bg.gif"));
		turnhieraciumFuscoatrumMenuItem_2.setText("Turn \"Hieracium fuscoatrum Ngeli & Peter\" into a heterotypic synoynm");

		final MenuItem turnhieraciumFuscoatrumMenuItem_3 = new MenuItem(menu1, SWT.NONE);
		turnhieraciumFuscoatrumMenuItem_3.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/basionym_no_bg.gif"));
		turnhieraciumFuscoatrumMenuItem_3.setText("Turn \"Hieracium fuscoatrum Ngeli & Peter\" into a basionym");

		final MenuItem turnhieraciumFuscoatrumMenuItem_4 = new MenuItem(menu1, SWT.NONE);
		turnhieraciumFuscoatrumMenuItem_4.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/repsyn_no_bg.gif"));
		turnhieraciumFuscoatrumMenuItem_4.setText("Turn \"Hieracium fuscoatrum Ngeli & Peter\" into a replaced synonym");

		final MenuItem turnhieraciumFuscoatrumMenuItem_5 = new MenuItem(menu1, SWT.NONE);
		turnhieraciumFuscoatrumMenuItem_5.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/homonym_no_bg.gif"));
		turnhieraciumFuscoatrumMenuItem_5.setText("Turn \"Hieracium fuscoatrum Ngeli & Peter\" into a homonym");

		final MenuItem turnhieraciumFuscoatrumMenuItem_6 = new MenuItem(menu1, SWT.NONE);
		turnhieraciumFuscoatrumMenuItem_6.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/orthovariant_no_bg.gif"));
		turnhieraciumFuscoatrumMenuItem_6.setText("Turn \"Hieracium fuscoatrum Ngeli & Peter\" into a orthographic variant");

		final MenuItem turnhieraciumFuscoatrumMenuItem_7 = new MenuItem(menu1, SWT.NONE);
		turnhieraciumFuscoatrumMenuItem_7.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/misapplied_no_bg.gif"));
		turnhieraciumFuscoatrumMenuItem_7.setText("Turn \"Hieracium fuscoatrum Ngeli & Peter\" into a misapplied name");

		final MenuItem turnhieraciumFuscoatrumMenuItem_8 = new MenuItem(menu1, SWT.NONE);
		turnhieraciumFuscoatrumMenuItem_8.setImage(ResourceManager.getPluginImage(Activator.getDefault(), "icons/concept_no_bg.gif"));
		turnhieraciumFuscoatrumMenuItem_8.setText("Turn \"Hieracium fuscoatrum Ngeli & Peter\" into a concept relation");

		SourceViewer sourceviewer = new SourceViewer(composite, null, SWT.WRAP | SWT.FULL_SELECTION);
		sourceviewer.setAnnotationHover(null);
		styledText = sourceviewer.getTextWidget();
		final GridData gd_styledText = new GridData(SWT.FILL, SWT.TOP, true, false);
		gd_styledText.heightHint = 41;
		gd_styledText.widthHint = 450;
		styledText.setLayoutData(gd_styledText);
		sourceviewer.setDocument(doc);
		sourceviewer.configure(new MySourceViewerConfig());
		sourceviewer.setTabsToSpacesConverter(null);

		
//		final Menu menu = new Menu(toolBar);
//		addDropDown(newItemToolItem, menu);
//		);
		
//		Action testAction = new ActionOpenNameEditor();
//		testAction.setImageDescriptor(ResourceManager.getPluginImageDescriptor(Activator.getDefault(), "icons/edit_16x16.gif"));
//		testAction.setToolTipText("Add relation");
//		toolBar.add(testAction);
		
		populateForm();		
	}

//	private void populateForm() {
//		
//		String fulltext = "";
//		
//		if (taxonname.getGenus() != null) {
//			fulltext = taxonname.getGenus();
//		}
//
//		if (taxonname.getSpecificEpithet() != null) {
//			fulltext += " " + taxonname.getSpecificEpithet();
//		}
//
//		if (taxonname.getAuthorship() != null) {
//			fulltext += " " + taxonname.getAuthorship();
//		}
//		
////		txtPlay.setText(fulltext);
////		txtPlay.setToolTipText("Joe mama\njoe daddy\njoe gramammy");
//		
//		this.setPartName(taxonname.getName());
//	}

	private void populateForm() {
		this.setPartName("Pilosella fuscoatra (Ngeli & Peter) Sojk");
	}
	
	@Override
	public void setFocus() {
		// Set the focus
	}

	@Override
	public void doSave(IProgressMonitor monitor) {
		// Do the Save operation
	}

	@Override
	public void doSaveAs() {
		// Do the Save As operation
	}

	@Override
	public void init(IEditorSite site, IEditorInput input) throws PartInitException {

		if (!(input instanceof IEditorInput))
			throw new PartInitException(
					"Invalid Input: Must be IFileEditorInput");
		
		if (input.getAdapter(TaxonName.class) != null) {
			taxonname = (TaxonName) input.getAdapter(TaxonName.class);
//			taxonname.addCdmEventListener(this);
		} else {
			
			taxonname = null;
		}
		
		setSite(site);
		setInput(input);
	}

	@Override
	public boolean isDirty() {
		return true;
	}

	@Override
	public boolean isSaveAsAllowed() {
		return false;
	}

	public void propertyChange(PropertyChangeEvent evt) {
//		TaxonName taxonname = (TaxonName)evt.getNewValue();
		this.taxonname = (TaxonName)evt.getNewValue();
		System.out.println(((TaxonName)evt.getNewValue()).getName());
		populateForm();
		
		// for individual fields, do something like:
		//	if (evt.getPropertyName().equalsIgnoreCase("genus"))
		//		txtGenus.setText ...
	}

//	public void onDelete(ICdmEventListenerRegistration arg0) {
//		// TODO Auto-generated method stub
//		
//	}

	public void onInsert(Object arg0) {
		// TODO Auto-generated method stub
		
	}

	public void onLoad(Object arg0) {
		// TODO Auto-generated method stub
		
	}

//	public void onUpdate(ICdmEventListenerRegistration arg0) {
//		// TODO Auto-generated method stub
//		
//	}
	
	private static void addDropDown(final ToolItem item, final Menu menu) {
		item.addListener(SWT.Selection, new Listener() {
			public void handleEvent(Event event) {
				if (event.detail == SWT.ARROW) {
					Rectangle rect = item.getBounds();
					Point pt = new Point(rect.x, rect.y + rect.height);
					pt = item.getParent().toDisplay(pt);
					menu.setLocation(pt.x, pt.y);
					menu.setVisible(true);
				}
			}
		});
	}
}
